package me.mctp.utils;

import me.mctp.xutils.SkullUtils;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class MultiPageGUI {
    private List<Inventory> inventories = new ArrayList<>();

    public MultiPageGUI(String title, int itemsPerPage, List<ItemStack> items) {
        if (!title.contains("%page%")) {
            throw new IllegalArgumentException("Title must contain %page% for the page.");
        }

        int invSize = itemsPerPage + 9;

        if (itemsPerPage%9 != 0) {
            throw new IllegalArgumentException("ItemsPerPage must be divisible by 9.");
        }

        int neededInvs = ((int) Math.ceil(items.size() / invSize));

        for (int i = 0; i < neededInvs; i++) {
            //Create inv
            Inventory inv = Bukkit.createInventory(null, invSize - 1, title.replace("%page%", String.valueOf(i + 1)));
            inventories.add(inv);

            //Add navigation
            ItemStack previous = SkullUtils.getSkull(UUID.fromString("a68f0b64-8d14-4000-a95f-4b9ba14f8df9"));
            ItemMeta previousMeta = previous.getItemMeta();
            previousMeta.setDisplayName(ChatColor.GOLD + "<< Vorige Pagina");
            previous.setItemMeta(previousMeta);

            ItemStack close = new ItemStack(Material.BARRIER, 1);
            ItemMeta closeMeta = close.getItemMeta();
            closeMeta.setDisplayName(ChatColor.RED + "Sluit Menu");
            close.setItemMeta(closeMeta);

            ItemStack next = SkullUtils.getSkull(UUID.fromString("50c8510b-5ea0-4d60-be9a-7d542d6cd156"));
            ItemMeta nextMeta = next.getItemMeta();
            nextMeta.setDisplayName(ChatColor.GOLD + "Volgende Pagina >>");
            next.setItemMeta(nextMeta);

            inv.setItem(itemsPerPage, previous);
            inv.setItem(itemsPerPage + 4, close);
            inv.setItem(itemsPerPage + 8, next);
        }
    }
}
